#include "pk_simple_ini_settings.h"

/*
 * Autor:
 * Philipp Kolb
 * http://philipp-kolb.net
 */

pk_simple_ini_settings::pk_simple_ini_settings(QString ini_path,QObject *parent) :
    QObject(parent)
{
    p_qsettings = new QSettings(ini_path,QSettings::IniFormat);
    p_qsettings->setFallbacksEnabled(false);
    p_qsettings->beginGroup(PK_SIMPLE_INI_SETTINGS_SINGLE_GROUP_NAME);
}

// Public Funktionen

QString pk_simple_ini_settings::get_setting_str(QString id, QString default_value)
{
    QVariant temp;
    temp = p_qsettings->value(id, default_value);
    return temp.toString();
}

int pk_simple_ini_settings::get_setting_num(QString id, int default_value)
{
    QVariant temp;
    temp = p_qsettings->value(id, default_value);
    return temp.toInt();
}

bool pk_simple_ini_settings::check_setting_id_exist(QString id)
{
    if (p_qsettings->value(id,"#sim_ini_false_return") == "#sim_ini_false_return")
        return false;
    else
        return true;
}

void pk_simple_ini_settings::set_setting_str(QString id, QString value)
{
    p_qsettings->setValue(id,value);
}

void pk_simple_ini_settings::set_setting_num(QString id, int value)
{
    p_qsettings->setValue(id,value);
}

bool pk_simple_ini_settings::remove_setting(QString id)
{
    p_qsettings->remove(id);
    return check_setting_id_exist(id); // Verifizieren
}

bool pk_simple_ini_settings::save_all_settings()
{
    p_qsettings->sync();
    if (p_qsettings->status() == 0)
        return true;
    else
        return false;
}

// Aufräumen
pk_simple_ini_settings::~pk_simple_ini_settings()
{
    p_qsettings->endGroup();
    save_all_settings();
    delete p_qsettings;
}
